function [hranice2KKO,hranice1KKO, tep_PPG, tep_EKG, BAR, C, vysledek] = BP_analyza_PPG(PPG_bu, Body, Fs, Pole)
% funkce na analzu PPG signlu na zlkad hodnoty BAR, PC a rozdlu
% tepovch frekvenc
if length(Body) <= length(Pole)
   L = length(Body);
else
   L = length(Pole);
end
if L<Fs*10
     O = L;
else O = round(Fs*10);
end
hranice2KKO = []; hranice1KKO = [];
 m=0;
while O > 0
PPG_f = PPG_bu(m+1:m+O); 
body1 = Body(1,m+1:m+O); body_diastoly = find(body1>0); 
body2 = Body(2,m+1:m+O); body_systoly = find(body2>0); 
pole = Pole(m+1:m+O);
hranice2KO = zeros(1,length(body1)); hranice1KO = zeros(1,length(body1));
%% PP a RR prmrn intervaly
a_PPG = body_systoly./Fs;
d = diff(a_PPG); PP = mean(d);
x_EKG = find(pole(1,:)>0)./Fs;
y = diff(x_EKG); RR = mean(y);
rozdil = length(a_PPG)-length(x_EKG);
%% Standardn odchylka NN interval
sdPP = std(d);
sdRR = std(y);
if length(d) > 3 
d2 = abs(diff(d));
%% rMSSD
rMPPD = sqrt(sum(d2)/((length(d2)-1)^2))/Fs;
%% pNN50
pPP50 = length(find(d2>0.05))/length(d2)*100;
else 
rMPPD = 100*Fs;
pPP50 = 100;
end
y2 = abs(diff(y));
rMRRD = sqrt(sum(y2)/((length(y2)-1)^2))/Fs;
pRR50 = length(find(y2>0.05))/length(y2)*100;
%% Tepov frekvence
tep_PPG = round(60/PP);
tep_EKG = round(60/RR);
%% BAR
souhrn = [PP,sdPP,rMPPD,pPP50,tep_PPG; RR,sdRR,rMRRD,pRR50,tep_EKG];
bias = (sum(souhrn(1,:)-souhrn(2,:)))/length(souhrn);
SD = sqrt((sum((souhrn(1,:)-souhrn(2,:)-bias).^2))/(length(souhrn)-1));   
L = (sum(souhrn(1,:)+souhrn(2,:)./2))/length(souhrn);
BAR = round(19.6*SD/L);
%% Korelace se ablonou
M = round(median(diff(body_diastoly))/2); a = 1; b = 0;
a = min(find(body_diastoly>M));
b = max(find(body_diastoly<(length(PPG_f)-M)));
% Tvorba templtu
P = [];
for n = a:b
    POM = PPG_f(body_diastoly(n)-M:body_diastoly(n)+M);
    P = [P; POM];
end
if size(P,1)>1
   P = sum(P)/size(P,1); 
end
% Korelace s templtem
C = [];
for n = a:b
    PC = corrcoef(PPG_f(body_diastoly(n)-M:body_diastoly(n)+M),P);
    C = [C; PC(1,2)];
end
C = round(sum(C)/size(C,1)*100)/100;
%% VYHODNOCEN
% analza kvality 1,2 a 3
if   C > 0.86 && BAR <= 20 && abs(tep_PPG-tep_EKG)<=3
    hranice2KO(:) = 10;
    vysledek = 'Analyza do kvality 2';
else vysledek = 'Analyza do kvality 3';
end
hranice2KKO = [hranice2KKO, hranice2KO];
% analza kvality 1
if C > 0.97 && BAR <= 10 && abs(tep_PPG-tep_EKG)<3
    hranice1KO(:) = 10;
    vysledek = 'Analyza do kvality 1';
end
hranice1KKO = [hranice1KKO, hranice1KO];

m = m+O;
 if m+O > length(Body) 
    O = 0;
 end
end

end