clear all; clc; 
% Tento soubor nese funkce pro stanoven kvality a analzu PPG signl, je jsou uloeny 
%v bukovch polch a1-a108.mat. Tato pole obsahuj nsledujc poloky:
% Fs - snmkovac frekvence chytrho telefonu, jm byl PPG signl pozen
% PPGC - PPG signl z ervenho kanlu
% PPGZ - PPG signl ze zelenho kanlu
% PPGM - PPG signl z modrho kanlu
% pole_znacek - uloeny pozice R vln v EKG signlu
% EKG = referenn EKG signl
% info - informace o typu chytrho telefonu a druhu artefaktu, kter se v
% PPG signlu vyskytuje
load('a10.mat', 'snimani'); % naetn bukovho pole (a1 - a108), ve kterm je PPG a EKG signl a pozice R pk
Fs = snimani{1,2}; PPGC = -snimani{2,2}; pole_znacek = snimani{5,2}; PPGZ = -snimani{3,2}; PPGM = -snimani{4,2}; EKG = snimani{6,2};

PPG = PPGC(1:end); % volba PPG signlu z jednoho barevnho kanlu (ervenho), se kterm se bude dle pracovat
%% Pedzpracovn signlu
[PPG_butter1, PPG_butter2] = BP_filtrace(PPG, Fs);
%% Nalezen systolickch pk a pat vln
[Body] = BP_bodyvln(PPG_butter2, Fs);
%% Prvn a druh kvalita signlu - piatost a perfuze
[sikmost, perfuze, spn, spicatost, hranice2K, hranice1K, vysledek_kvality] = BP_stanoveni_kvality(PPG, PPG_butter2, Fs);
vysledek_kvality
%% Analza PPG signlu
[hranice2KO, hranice1KO, TFp_PPG, TFp_EKG, BAR, C, vysledek_analyzy] = BP_analyza_PPG(PPG_butter2,Body,Fs, pole_znacek);
vysledek_analyzy
%% Grafy
% Systolick pky s detekovanmi R vlnami
figure 
plot(Body(2,:)); hold on; plot(PPG_butter2); hold on; plot(-pole_znacek);
legend('Systolick pk','PPG_filt', 'R vlny')
% RAW PPG signly z ervenho, zelenho a modrho kanlu videozznamu
figure
plot((PPGC-mean(PPGC))./std(PPGC), 'r'); hold on; plot((PPGZ-mean(PPGZ))./std(PPGZ),'g'); hold on; plot((PPGM-mean(PPGM))./std(PPGM),'b'); 
title('Raw PPG signaly'); xlabel('Vzorky [-]'); ylabel('Vchylka [-]'); legend('PPGC', 'PPGZ', 'PPZM')
% Hondoty perfuze, ikmosti, piatosti a spn
figure
plot(PPG_butter2,'LineWidth',1); hold on; plot(perfuze,'LineWidth',1); hold on; plot(sikmost,'LineWidth',1); hold on; plot(spicatost,'LineWidth',1); hold on; plot(spn,'LineWidth',1);
legend('Filtrovan PPG signl','Perfuze','ikmost','piatost', 'SPN')
xlabel('Vzorky [-]'); ylabel('Vchylka [-]')
% %% oven 2. kvality
% figure
% subplot(211)
% h = area(hranice2KO); h.FaceColor = [0 0.75 0.75]; title('Kontrola vymezen 1. kvality'); xlabel('Vzorky [-]'); ylabel('Vchylka [-]');
% hold on 
% h = area(hranice2K); h.FaceColor = [0.75 0 0.75]; title('Kontrola vymezen 2. kvality'); xlabel('Vzorky [-]'); ylabel('Vchylka [-]');
% hold on
%  plot(PPG_butter2,'black');
% legend('Kontrola vymezen 2. kvality','Vymezen 2. kvality','Filtrovany signl'); 
% %% oven 1. kvality
% subplot(212)
% h = area(hranice1KO); h.FaceColor = [0 0.75 0.75]; title('Kontrola vymezen 1. kvality'); xlabel('Vzorky [-]'); ylabel('Vchylka [-]');
% hold on 
% h = area(hranice1K); h.FaceColor = [0.75 0 0.75]; title('Kontrola vymezen 1. kvality'); xlabel('Vzorky [-]'); ylabel('Vchylka [-]');
% plot(PPG_butter1,'black') 
% legend('Kontrola vymezen 1. kvality','Vymezen 1. kvality', 'Filtrovan signl'); 