function [SIKMOST, PERFUZE, ZCR, SPICATOST, hranice2K, hranice1K, vysledek] = BP_stanoveni_kvality(PPG, PPG_tf, Fs)
% funkce pro stanoven kvality PPG signlu podle hodnot jeho perfuze,
% ikmosti, piatosti a sumy prchod nulou (spn)
% signl je dlen do t td kvality
O = round(Fs*2); % segmenty o dlce 2 s
if O > length(PPG)
    O = length(PPG);
end
hranice2KK = []; hranice1KK = []; m = 0; SIKMOST = []; PERFUZE = []; ZCR = []; SPICATOST = []; 
while O > 0
PPGTF = -PPG_tf(m+1:m+O); PPg = -PPG(m+1:m+O); % Filtrovan a raw PPG signl rozdlen na seky po 2 s
%% piatost a perfuze PPG signlu
    perfuze = round(((max(PPGTF)-min(PPGTF))/abs(mean(PPg)))*100,1);
    sikmost = round(skewness(PPGTF),1);
    spicatost = round(kurtosis(PPGTF),1);
    spn = 0; 
    for n = 2:length(PPGTF)
        if PPGTF(n-1) > 0 && PPGTF(n) <= 0
            spn = spn + 1;
        elseif PPGTF(n-1) < 0 && PPGTF(n) >= 0
            spn = spn + 1;
        end
    end
%% Uloen hodnot
S_vektor = zeros(1,length(PPGTF)); S_vektor(:) = sikmost;
P_vektor= zeros(1,length(PPGTF));  P_vektor(:) = perfuze;
K_vektor= zeros(1,length(PPGTF));  K_vektor(:) = spicatost;
ZCR_vektor = zeros(1,length(PPGTF));  ZCR_vektor(:) = spn;
SIKMOST = [SIKMOST, S_vektor]; PERFUZE = [PERFUZE, P_vektor]; 
ZCR = [ZCR, ZCR_vektor]; SPICATOST = [SPICATOST, K_vektor];

m = m+O;
 if m+O > length(PPG) 
    O = length(PPG)-m-1;
     if O < Fs
         O = 0;
     end
 end
end
%% VYHODNOCEN
% hranice kvality 3 a 1,2
 hranice2K = zeros(1,length(PPG)); 
 p1 = median(PERFUZE) < 2.4;
 p2 = median(SIKMOST) >= 0;
 p3 = median(SPICATOST) < 2.4;
 p4 = abs(max(ZCR)-min(ZCR)) <= 3;
 p5 = max(diff(ZCR)) < 3;
     if   p1 ==1 && p3 == 1 && p2 == 1 && p4 == 1 && p5 == 1 
       hranice2K(:) = 5;
       vysledek =  'Uren do kvality 2';
     else vysledek = 'Uren do kvality 3';
     end
     
% hranice kvality 1
hranice1K = zeros(1,length(PPG));
 k1 = median(PERFUZE) < 2;
 k2 = round(median(SIKMOST),1) >= 0.2;
 k3 = median(SPICATOST) <= 2;
 k4 = abs(max(ZCR)-min(ZCR)) < 3;
 k5 = max(diff(ZCR))<2;
     if   k1 ==1 && k3 == 1 && k2 == 1 && k4 == 1 && k5 == 1 
       hranice1K(:) = 5;
       vysledek = 'Uren do kvality 1';
     end
end


